function v = bdDiff(u, tstep, dim)
%% Backward Difference in direciton dim with step size tstep

% Note: works channel wise. Mirrors data at boundary.

% Copyright (c) 2016 Laurent Hoeltgen <hoeltgen@b-tu.de>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision: 2016-12-02 14:00

switch dim
    case 'x'
        v = -flip(fdDiff(flip(u, 2), tstep, dim), 2);
    case 'y'
        v = -flip(fdDiff(flip(u, 1), tstep, dim), 1);
end
end
