function v = fdDiff(u, tstep, dim)
%% Forward Difference in direction dim with step size tstep

% Note: works channel wise. Mirrors data at boundary.

% Copyright (c) 2016 Laurent Hoeltgen <hoeltgen@b-tu.de>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision: 2016-12-02 10:00

switch dim
    case 'x'
        v = padarray(u, [0, 1], 'symmetric', 'post');
        v = diff(v, 1, 2)/tstep;
    case 'y'
        v = padarray(u, [1, 0], 'symmetric', 'post');
        v = diff(v, 1, 1)/tstep;
end
end