function tests = JordanProducttest()
%% Unit Tests for JordanProduct
%
% Example
%
% results = runtests('JordanProducttest.m')
%
% See also absmat

% Copyright (c) 2016 Laurent Hoeltgen <hoeltgen@b-tu.de>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision: 2016-12-10 21:00

tests = functiontests(localfunctions);
end

function testmat1(testCase)
import MatrixOps.JordanProduct

for i = -10:10
    for j = -10:10
        A = (10^i)*(2*rand(2,2) - 1);
        B = (10^j)*(2*rand(2,2) - 1);
        verifyEqual(testCase, ...
            JordanProduct(A,B), (A*B + B*A)/2, 'AbsTol', 1e-12);
    end
end
end

function testmat2(testCase)
import MatrixOps.JordanProduct

for i = -10:10
    for j = -10:10
        A = (2*rand(2,2) - 1) .* [10^i, 10^j; 10^j, 10^i];
        B = (2*rand(2,2) - 1);
        verifyEqual(testCase, ...
            JordanProduct(A,B), (A*B + B*A)/2, 'AbsTol', 1e-12);
    end
end
end

function testmat3(testCase)
import MatrixOps.JordanProduct

for i = -10:10
    for j = -10:10
        A = (2*rand(2,2) - 1) .* [10^i, 10^i; 10^j, 10^j];
        B = (2*rand(2,2) - 1);
        verifyEqual(testCase, ...
            JordanProduct(A,B), (A*B + B*A)/2, 'AbsTol', 1e-12);
    end
end
end
