function tests = RTdifftest()
%% Unit Tests for RTdiff
%
% Example
%
% results = runtests('JordanProducttest.m')
%
% See also RTdiff

% Copyright (c) 2016 Laurent Hoeltgen <hoeltgen@b-tu.de>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision: 2016-12-10 21:00

tests = functiontests(localfunctions);
end

function testmat1(testCase)
import PDEMorphology.RTdiff

u = zeros(3, 3, 2, 2);
u(2, 2, :, :) = eye(2,2);
v = RTdiff(u, 1, 'x');

verifyEqual(testCase, ...
   v{1,1}, zeros(2,2), 'AbsTol', 1e-12);
verifyEqual(testCase, ...
   v{1,2}, zeros(2,2), 'AbsTol', 1e-12);
verifyEqual(testCase, ...
   v{1,3}, zeros(2,2), 'AbsTol', 1e-12);

verifyEqual(testCase, ...
   v{2,1}, zeros(2,2), 'AbsTol', 1e-12);
verifyEqual(testCase, ...
   v{2,2}, eye(2,2), 'AbsTol', 1e-12);
verifyEqual(testCase, ...
   v{2,3}, zeros(2,2), 'AbsTol', 1e-12);

verifyEqual(testCase, ...
   v{3,1}, zeros(2,2), 'AbsTol', 1e-12);
verifyEqual(testCase, ...
   v{3,2}, zeros(2,2), 'AbsTol', 1e-12);
verifyEqual(testCase, ...
   v{3,3}, zeros(2,2), 'AbsTol', 1e-12);

end
