function tests = absMattest()
%% Unit Tests for absMat
%
% Example
%
% results = runtests('absMattest.m')
%
% See also absMat

% Copyright (c) 2016 Laurent Hoeltgen <hoeltgen@b-tu.de>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision: 2016-12-02 10:00

tests = functiontests(localfunctions);
end

function testmat1(testCase)
import MatrixOps.absMat

X = [2, -1; -1, 2];
verifyEqual(testCase, ...
    absMat(X), X, 'AbsTol', 1e-12);
end

function testmat2(testCase)
import MatrixOps.absMat

X = [-2, 1; 1, -2];
verifyEqual(testCase, ...
    absMat(X), -X, 'AbsTol', 1e-12);
end

function testmat3(testCase)
import MatrixOps.absMat

X = [1, -1; -1, 2];
verifyEqual(testCase, ...
    absMat(X), [sqrt(1+1/sqrt(5)), -sqrt(1-1/sqrt(5)); ...
    -sqrt(5/2-1/sqrt(5)), sqrt(5/2+1/sqrt(5))], 'AbsTol', 1e-12);
end