function tests = compareConestest()
%% Unit Tests for compareCones
%
% Example
%
% results = runtests('compareConestest.m')
%
% See also compareCones

% Copyright (c) 2016 Laurent Hoeltgen <hoeltgen@b-tu.de>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision: 2016-05-17 16:00

tests = functiontests(localfunctions);
end

%% Due to rounding errors it may happen that we are off by one pixel value.
function testcompare1(testCase)
import ColourCone.compareCones

mx = [1, 0; 0, 1];
my = [0, 0; 0, 0];

verifyEqual(testCase, compareCones(mx, my),  1);
verifyEqual(testCase, compareCones(my, mx), -1);
verifyEqual(testCase, compareCones(mx, mx),  0);
verifyEqual(testCase, compareCones(my, my),  0);
end

function testcompare2(testCase)
import ColourCone.compareCones

mx = [1, 0; 0, -0.5];
my = [0, 0; 0, 0];

verifyEqual(testCase, compareCones(mx, my),  1);
verifyEqual(testCase, compareCones(my, mx), -1);
end

function testcompare3(testCase)
import ColourCone.compareCones

mx = [-1, 0; 0, 0.5];
my = [0, 0; 0, 0];

verifyEqual(testCase, compareCones(mx, my), -1);
verifyEqual(testCase, compareCones(my, mx),  1);
end

function testcompare4(testCase)
import ColourCone.compareCones

mx = [1, 0; 0, -1];
my = [0, 0; 0, 0];

verifyEqual(testCase, compareCones(mx, my), 0);
verifyEqual(testCase, compareCones(my, mx), 0);
end

function testcompare5(testCase)
import ColourCone.compareCones

mx = [12, 2; 2, 8];
my = [5, 1; 1, 3];

verifyEqual(testCase, compareCones(mx, my),  1);
verifyEqual(testCase, compareCones(my, mx), -1);
end

function testcompare6(testCase)
import ColourCone.compareCones

mx = [1, 2; 2, -1];
my = [0, 0; 0, 0];

verifyEqual(testCase, compareCones(mx, my), 0);
verifyEqual(testCase, compareCones(my, mx), 0);
end