function tests = minMattest()
%% Unit Tests for minMat
%
% Example
%
% results = runtests('minMattest.m')
%
% See also minMat

% Copyright (c) 2016 Laurent Hoeltgen <hoeltgen@b-tu.de>
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
% Street, Fifth Floor, Boston, MA 02110-1301, USA.

% Last revision: 2016-12-02 10:00

tests = functiontests(localfunctions);
end

function testmat1(testCase)
import MatrixOps.minMat

X = [2, -1; -1, 2];
verifyEqual(testCase, ...
    minMat(X, [0,0;0,0]), [0,0;0,0], 'AbsTol', 1e-12);
end

function testmat2(testCase)
import MatrixOps.minMat

X = [-2, 1; 1, -2];
verifyEqual(testCase, ...
    minMat(X, [0,0;0,0]), X, 'AbsTol', 1e-12);
end
